程序師世界是廣大編程愛好者互助、分享、學習的平台,程序師世界有你更精彩!
首頁
編程語言
C語言|JAVA編程
Python編程
網頁編程
ASP編程|PHP編程
JSP編程
數據庫知識
MYSQL數據庫|SqlServer數據庫
Oracle數據庫|DB2數據庫
 程式師世界 >> 編程語言 >> C語言 >> C >> 關於C >> 2006 ACM Northwestern European Programming Contest C題(二分求最大)

2006 ACM Northwestern European Programming Contest C題(二分求最大)

編輯:關於C

My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a numberN of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

Input

One line with a positive integer: the number of test cases. Then for each test case:

One line with two integers N and F with 1 ≤N, F ≤ 10000: the number of pies and the number of friends. One line with N integers ri with 1 ≤ri ≤ 10000: the radii of the pies.

Output

For each test case, output one line with the largest possible volumeV such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10-3.

Sample Input

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

Sample Output

25.1327
3.1416
50.2655
The 2006 ACM Northwestern European Programming Contest

題意:有F+1個人來分圓形的派,每人只能分一整塊,不能幾塊拼起來,且面積相同,求每人最多分到多大的派(不必是圓形,但是要一整塊) 思路:問題其實就是是否讓每人分到一塊面積為x的派,我們可以嘗試著去試這個x,直到x太大,不能分給F+1個人為止,所以二分法又派上用場了,二分法真正思想其實很博大精深,不是說你會用二分法查找有序列裡的一個數你就會二分法了,其實還在門外,好了這道題對於這裡的半徑為r的派,只能切出PI*r*r* / x個派,把所有的圓切一遍,再判斷是否夠分就可以了。
#include 
#include 
using namespace std;

#define MAX(a, b) ((a) > (b) ? (a) : (b)) 

const int maxn = 10010;
const double PI = acos(-1.0);
double s[maxn];
int n, f, r;

int ok(double x)
{
	int sum = 0;
	for (int i = 0; i < n; i++) sum += floor(s[i] / x);
	return sum >= f + 1;
}

int main()
{
	int T;
	cin>>T;
	while (T--)
	{
		cin>>n>>f;
		double max = -1;//找最大圓的面積
		for (int i = 0; i < n; i++)
		{
			cin>>r;
			s[i] = PI * r * r;
			max = MAX(max, s[i]);
		}

		//二分找最大
		double L = 0, R = max;
		while (R - L > 1e-5)
		{
			double M = (L + R) / 2;
			if (ok(M)) L = M;
			else R = M;
		}
		printf("%.5lf\n", L);
	}
	return 0;
}





  1. 上一頁:
  2. 下一頁:
Copyright © 程式師世界 All Rights Reserved